/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.commons;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import org.blueoxygen.cimande.persistence.GenericPersistenceManager;
import org.blueoxygen.cimande.security.SessionCredentials;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.util.PropertyLooker;
import org.springframework.beans.factory.annotation.Autowired;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

/**
 * @author leo
 * @author Dian Aditya
 * 
 */
public class CimandeAction extends ActionSupport implements
		ModelDriven<Object>, ServletRequestAware, ServletResponseAware {
	protected Orderby ob = new Orderby();

	@Deprecated
	@Autowired
	protected GenericPersistenceManager manager;

	@Autowired
	protected SessionCredentials sessionCredentials;

	protected HttpServletRequest request;
	protected HttpServletResponse response;

	protected Object rootModel = new Object();
	protected Map<String, Object> model = new HashMap<String, Object>();

	private static Properties properties = new Properties();
	static {
		try {
			properties.load(PropertyLooker
					.getResourceAsStream("cimande.properties"));
		} catch (IOException e) {
			e.printStackTrace();
		} catch (NullPointerException npe) {
			LOG.info("file cimande.properties is not in classpath");
			npe.printStackTrace();
		}
	}

	public static String get(String propertyName) {
		return properties.getProperty(propertyName);
	}

	public User getCurrentUser() {
		return sessionCredentials.getCurrentUser();
	}

	public Object getModel() {
		return model.size() > 0 ? model : rootModel;
	}

	public void setServletResponse(HttpServletResponse response) {
		this.response = response;
	}

	public void setServletRequest(HttpServletRequest request) {
		this.request = request;
	}
}
