/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.descriptors.actions;

import java.util.Date;

import org.blueoxygen.cimande.descriptors.Descriptor;

import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

/*******************************
 * @author Praditya Eldorado aldo.donal@gmail.com
 *******************************/

@Validation
public class AddDescriptor extends DescriptorForm {
	private Descriptor des = new Descriptor();
	private Date date = new Date();
	private Date date2 = new Date();

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "name", message = "Please input name"),
			@RequiredStringValidator(fieldName = "description", message = "Please input description") })
	public String execute() {

		if (hasErrors()) {
			return INPUT;

		} else {
			des.setName(getName());
			des.setDescription(getDescription());
			des.setUrlDescriptor(getUrlDescriptor());
			des.setUrlAction(getUrlAction());
			service.save(des);
			return SUCCESS;
		}

	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public Date getDate2() {
		return date2;
	}

	public void setDate2(Date date2) {
		this.date2 = date2;
	}

}