/**
 * ModuleFunctionDAO.java
 * 
 * Created on May 16, 2011 1:30:18 AM
 */
package org.blueoxygen.cimande.modulefunction.dao;

import java.util.List;

import org.blueoxygen.cimande.modulefunction.ModuleFunction;
import org.blueoxygen.cimande.persistence.hibernate.dao.HibernatePersistenceDaoManager;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

/**
 * @author Dian Aditya
 * 
 */
@Repository
public class ModuleFunctionDAO extends
		HibernatePersistenceDaoManager<ModuleFunction> {

	public void save(ModuleFunction moduleFunction) {
		if (moduleFunction != null) {
			if (moduleFunction.getId() == null
					|| "".equalsIgnoreCase(moduleFunction.getId())) {
				moduleFunction.getLogInformation().setCreateBy(
						getCurrentUser().getId());
				moduleFunction.getLogInformation().setLastUpdateBy(
						getCurrentUser().getId());
				moduleFunction.getLogInformation().setCreateDate(
						getCurretTime());
				moduleFunction.getLogInformation().setLastUpdateDate(
						getCurretTime());
				moduleFunction.getLogInformation().setActiveFlag(1);

				persist(moduleFunction);
			} else {
				moduleFunction.getLogInformation().setLastUpdateBy(
						getCurrentUser().getId());
				moduleFunction.getLogInformation().setLastUpdateDate(
						getCurretTime());

				merge(moduleFunction);
			}
		}
	}

	@SuppressWarnings("unchecked")
	public List<ModuleFunction> getModuleFunctionsByCriteria(String name,
			String description, String tableRef, String moduleFunctionId,
			String moduleDescriptorsId, String orderby, int maxResults,
			int firstResult) {
		Criteria criteria = getCriteria(name, description);
		criteria.addOrder(Order.asc(orderby));
		if (maxResults > 0)
			criteria.setMaxResults(maxResults);
		criteria.setFirstResult(firstResult);

		return criteria.list();
	}

	public long getRowCountByCriteria(String name, String description) {
		Criteria criteria = getCriteria(name, description);
		criteria.setProjection(Projections.rowCount());

		return new Long(criteria.uniqueResult() + "");
	}

	private Criteria getCriteria(String name, String description) {

		Criteria criteria = sessionFactory.getCurrentSession().createCriteria(
				ModuleFunction.class);
		criteria.add(Restrictions.like("name", name + "", MatchMode.ANYWHERE));
		criteria.add(Restrictions.like("description", description + "",
				MatchMode.ANYWHERE));
		return criteria;
	}
}
