/**
 * ModuleFunctionServiceImpl.java
 *
 * Created on 29 Agu 2010 12:07:20
 */
package org.blueoxygen.cimande.modulefunction.service;

import java.util.ArrayList;
import java.util.List;
import org.blueoxygen.cimande.modulefunction.ModuleFunction;
import org.blueoxygen.cimande.modulefunction.dao.ModuleFunctionDAO;
import org.blueoxygen.cimande.persistence.hibernate.dao.HibernatePersistenceDaoManager;
import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author Dian Aditya
 * 
 */
@Service
@Transactional(readOnly = true)
public class ModuleFunctionServiceImpl implements ModuleFunctionService {

	@Autowired
	private ModuleFunctionDAO moduleFunctionDAO;

	@Transactional
	public void save(ModuleFunction moduleFunction) {
		moduleFunctionDAO.save(moduleFunction);
	}

	@Transactional
	public void delete(ModuleFunction moduleFunction) {
		moduleFunctionDAO.remove(moduleFunction);
	}

	public ModuleFunction getModuleFunctionById(String id) {
		return moduleFunctionDAO.getById(ModuleFunction.class, id);
	}

	public List<ModuleFunction> getModuleFunctionsByCriteria(String name,
			String description, String tableRef, String moduleFunctionId,
			String moduleDescriptorsId, String orderby, int maxResults,
			int firstResult) {

		return moduleFunctionDAO.getModuleFunctionsByCriteria(name,
				description, tableRef, moduleFunctionId, moduleDescriptorsId,
				orderby, maxResults, firstResult);
	}

	public long getRowCountByCriteria(String name, String description) {
		return moduleFunctionDAO.getRowCountByCriteria(name, description);
	}

}
