package org.blueoxygen.cimande.password;


import org.blueoxygen.cimande.security.UserAccessor;
import org.blueoxygen.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;

import com.opensymphony.xwork2.validator.annotations.FieldExpressionValidator;
import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.StringLengthFieldValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;
import com.opensymphony.xwork2.validator.annotations.ValidatorType;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

@Validation
public class UpdatePassword extends PasswordForm {
	private StringUtils su = new StringUtils();
	@Autowired
	private UserAccessor ua;

	@Validations(requiredStrings = {
			@RequiredStringValidator(type = ValidatorType.SIMPLE, fieldName = "currPassword", message = "Your current password is empty"),
			@RequiredStringValidator(type = ValidatorType.SIMPLE, fieldName = "newPassword", message = "Your new password is empty"),
			@RequiredStringValidator(type = ValidatorType.SIMPLE, fieldName = "verifyPassword", message = "Verify your new password") }, stringLengthFields = { @StringLengthFieldValidator(fieldName = "newPassword", minLength = "3", message = "Password minimum 3 character") }, fieldExpressions = { @FieldExpressionValidator(fieldName = "verifyPassword", expression = "newPassword == verifyPassword", message = "Verify your new Password") })
	public String execute() {
		if (!getCurrentUser().getPassword().equalsIgnoreCase(
				su.encodeBase64(getCurrPassword()))) {
			addFieldError("currPassword", "Your current password is invalid");
		}
		if (hasErrors()) {
			return INPUT;
		}
		user = service.getUserbyId(getCurrentUser().getId());
		user.setPassword(su.encodeBase64(getNewPassword()));
		service.save(user);
		return SUCCESS;
	}

}
