/**
 * GenericDAO.java
 *
 * Created on 06 Jul 2010 14:33:11
 */
package org.blueoxygen.cimande.persistence.dao;

import java.util.List;

/**
 * @author Dian Wahyu Aditya
 * 
 */

public interface PersistenceDaoManager<T> {
	static enum Direction {
		ASC, DESC
	}

	static enum Operation {
		AND("AND"), OR("OR");

		String string;

		Operation(String string) {
			this.string = string;
		}

		String getValue() {
			return string;
		}
	}

	static enum Expression {
		EQUALS("="), NOT_EQUALS("!="), LIKE("like");

		String string;

		private Expression(String string) {
			this.string = string;
		}

		String getValue() {
			return string;
		}
	}

	List<T> findAll(Class<T> type);

	List<T> findAllSorted(Class<T> type, String sortProperty);

	List<T> findAllSortedDirected(Class<T> type, String sortField,
			Direction direction);

	List<T> find(Class<T> type, String field, String contain);

	T getById(Class<T> type, String id);

	T getByUniqueField(Class<T> type, String id, String fieldName);

	void remove(T objectToRemove);

	void persist(T object);

	void merge(T object);
}
