/**
 * JsonContentHandler.java
 *
 * Created on 6 Sep 2010 15:05:49
 */
package org.blueoxygen.cimande.rest.handler;

import java.io.IOException;
import java.io.Writer;

import org.codehaus.jackson.JsonGenerationException;
import org.codehaus.jackson.map.JsonMappingException;
import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.map.SerializationConfig.Feature;

/**
 * @author Dian Aditya
 * 
 */
public class JsonContentHandler implements ContentHandler {

	public void fromObject(Object object, Writer writer) {
		try {
			ObjectMapper objectMapper = new ObjectMapper();
			objectMapper.configure(Feature.WRITE_NULL_MAP_VALUES, false);
			objectMapper.writeValue(writer, object);
		} catch (JsonGenerationException e) {
			e.printStackTrace();
		} catch (JsonMappingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String getContentType() {
		return "application/json";
	}

	public String getExtension() {
		return "json";
	}

}
