/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.role.actions;

import org.blueoxygen.cimande.role.Role;
import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

@Validation
public class AddRole extends RoleForm {
	private Role rl = new Role();

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "name", message = "Name can't be empty."),
			@RequiredStringValidator(fieldName = "description", message = "Description can't be empty.") })
	public String execute() {
		Role role = new Role();
		if (hasErrors()) {
			return INPUT;
		} else {

			if (getParentId() != null && !"".equalsIgnoreCase(getParentId())) {
				rl = service.getRoleById(getParentId());
			} else {
				rl = null;
			}

			role.setName(getName());
			role.setDescription(getDescription());
			role.setParentId(rl);
			if (getWorkspace_type().equalsIgnoreCase("")) {
				role.setWorkspace_type("tree");
			}
			role.setWorkspace_type(getWorkspace_type());
			service.save(role);
			return SUCCESS;
		}
	}

	public Role getRl() {
		return rl;
	}

	public void setRl(Role rl) {
		this.rl = rl;
	}

}