/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.role.actions;

import org.blueoxygen.cimande.commons.CimandeAction;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.role.actions.servicewfrole.ServiceWfRole;
import org.springframework.beans.factory.annotation.Autowired;

/*******************************
 * @author Praditya Eldorado
 * 		   aldo.donal@gmail.com
 *******************************/

public class ViewRole extends CimandeAction {

	protected Role role;
	protected @Autowired
	ServiceWfRole service;

	private String id;

	public String execute() {
		role = service.getRoleById(getId());
		model.put("role", role);

		if (role == null) {
			addActionError("Such role couldn't be found");
			return ERROR;
		} else {
			return SUCCESS;
		}
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getId() {
		return id;
	}

	public Role getRole() {
		return role;
	}
}