/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/
package org.blueoxygen.cimande.security;

import java.util.List;

import org.blueoxygen.cimande.persistence.GenericPersistenceManager;
import org.blueoxygen.cimande.persistence.PersistenceException;
import org.blueoxygen.util.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class DefaultUserAccessor implements UserAccessor {

	@Autowired
	private GenericPersistenceManager pm;
	private StringUtils su = new StringUtils();

	public boolean authenticate(String username, String password) {
		User user = getByUsername(username);

		if (user == null
				|| !user.getPassword().equals(su.encodeBase64(password))) {
			return false;
		} else {
			return true;
		}
	}

	public User getByUsername(String username) {
		try {
			return (User) pm.getByUniqueField(User.class, username, "username");
		} catch (PersistenceException e) {
			return null;
		}
	}

	// public User getByUsername(String username) {
	// try {
	// List users = findAllUser(username);
	//
	// if (users.isEmpty()) {
	// return null;
	// } else {
	// return (User) users.get(0);
	// }
	// } catch (PersistenceException e) {
	// return null;
	// }
	// }
	public void signup(User user) {
		pm.save(user);
	}

	public void update(User userEdited) {
		pm.save(userEdited);

	}

	public User getById(String userId) {

		return (User) pm.getById(User.class, userId);
	}

	public List<User> findAllUser() {
		try {
			return pm.findAll(User.class);
		} catch (Exception e) {
			throw new PersistenceException(e);
		}
	}

	public void delete(User user) {
		pm.remove(user);
	}
}
