package org.blueoxygen.cimande.security.usermanager.actions;

import java.util.ArrayList;
import java.util.List;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.cimande.site.actions.SiteForm;

public class SearchUser extends UserForm {
	private List users = new ArrayList();
	private int maxPage, currPage, nextPage, prevPage = 0, page = 0;
	private int maxRowPerPage = 10;
	private String orderBy = "username";
	private int resultRows;

	public String execute() {
		String first = getName().getFirst();
		String address1 = getAddress().getStreet1();
		resultRows = service.getRowCountByCriteria(getUser().getUsername(),
				first);
		maxPage = resultRows / maxRowPerPage;
		if (resultRows % maxRowPerPage == 0)
			maxPage = maxPage - 1;

		users = service.findUsers(getUser().getUsername(), first, getUser()
				.getEmail(), address1, getAddress().getCity(), getOrderBy(),
				getMaxRowPerPage(), currPage * maxRowPerPage);
		SiteForm form = new SiteForm();
		prevPage = currPage - 1;
		nextPage = currPage + 1;
		page = currPage + 1;

		model.put("userlist", getUsers());

		return SUCCESS;
	}

	/**
	 * @return Returns the currPage.
	 */
	public int getCurrPage() {
		return currPage;
	}

	/**
	 * @param currPage
	 *            The currPage to set.
	 */
	public void setCurrPage(int currPage) {
		this.currPage = currPage;
	}

	/**
	 * @return Returns the maxPage.
	 */
	public int getMaxPage() {
		return maxPage;
	}

	/**
	 * @param maxPage
	 *            The maxPage to set.
	 */
	public void setMaxPage(int maxPage) {
		this.maxPage = maxPage;
	}

	/**
	 * @return Returns the maxRowPerPage.
	 */
	public int getMaxRowPerPage() {
		return maxRowPerPage;
	}

	/**
	 * @param maxRowPerPage
	 *            The maxRowPerPage to set.
	 */
	public void setMaxRowPerPage(int maxRowPerPage) {
		this.maxRowPerPage = maxRowPerPage;
	}

	/**
	 * @return Returns the nextPage.
	 */
	public int getNextPage() {
		return nextPage;
	}

	/**
	 * @param nextPage
	 *            The nextPage to set.
	 */
	public void setNextPage(int nextPage) {
		this.nextPage = nextPage;
	}

	/**
	 * @return Returns the orderBy.
	 */
	public String getOrderBy() {
		return orderBy;
	}

	/**
	 * @param orderBy
	 *            The orderBy to set.
	 */
	public void setOrderBy(String orderBy) {
		this.orderBy = orderBy;
	}

	/**
	 * @return Returns the prevPage.
	 */
	public int getPrevPage() {
		return prevPage;
	}

	/**
	 * @param prevPage
	 *            The prevPage to set.
	 */
	public void setPrevPage(int prevPage) {
		this.prevPage = prevPage;
	}

	/**
	 * @return Returns the resultRows.
	 */
	public int getResultRows() {
		return resultRows;
	}

	/**
	 * @param resultRows
	 *            The resultRows to set.
	 */
	public void setResultRows(int resultRows) {
		this.resultRows = resultRows;
	}

	public int getPage() {
		return page;
	}

	public void setPage(int page) {
		this.page = page;
	}

	public List<User> getUsers() {
		return users;
	}

	public void setUsers(List<User> users) {
		this.users = users;
	}

}
