package org.blueoxygen.cimande.security.usermanager.service;

import org.blueoxygen.cimande.persistence.hibernate.dao.HibernatePersistenceDaoManager;
import org.blueoxygen.cimande.security.usermanager.UserSite;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

@Repository
@Transactional(readOnly = true)
public class UserSiteServiceImpl extends
		HibernatePersistenceDaoManager<UserSite> implements UserSiteService {
	@Transactional
	public void save(UserSite us) {
		if (us != null) {
			if (us.getId() == null || "".equalsIgnoreCase(us.getId())) {
				us.getLogInformation().setCreateBy(getCurrentUser().getId());
				us.getLogInformation()
						.setLastUpdateBy(getCurrentUser().getId());
				us.getLogInformation().setCreateDate(getCurretTime());
				us.getLogInformation().setLastUpdateDate(getCurretTime());
				us.getLogInformation().setActiveFlag(1);
				persist(us);
			} else {
				us.getLogInformation()
						.setLastUpdateBy(getCurrentUser().getId());
				us.getLogInformation().setLastUpdateDate(getCurretTime());
				merge(us);
			}

		}
	}

	public void delete(UserSite us) {
		if (us != null && us.getId() != null) {
			us = getById(UserSite.class, us.getId());
			remove(us);
		}
	}

	@Transactional(readOnly = true)
	public UserSite getUserSiteById(String id) {
		return getById(UserSite.class, id);
	}

}
