/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.site.actions;

import java.util.ArrayList;
import java.util.List;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

public class SearchSite extends SiteForm {

	private List sites = new ArrayList();

	private String orderBy = "name";
	private int maxPage, currPage, nextPage, prevPage = 0, page = 0;
	private int maxRowPerPage = 10;
	private int resultRows;

	public String execute() {

		resultRows = service.getRowCountByCriteria(getName(), getDescription(),
				getTitle(), getUrl_branding(), getSite_url(), getAdmin_email(),
				getNotify_email(), getNotify_from(), getNotify_message(),
				getWorkspace_type());

		maxPage = resultRows / maxRowPerPage;
		if (resultRows % maxRowPerPage == 0)
			maxPage = maxPage - 1;

		setActiveFlag(getActiveFlag() + 2);
		setNotify_flag(getNotify_flag() + 2);

		sites = service.findSites(getName(), getDescription(), getTitle(),
				getUrl_branding(), getSite_url(), getAdmin_email(),
				getNotify_flag(), getNotify_email(), getNotify_from(),
				getNotify_message(), getActiveFlag(), getWorkspace_type(),
				getOrderBy(), getMaxRowPerPage(), currPage * maxRowPerPage);

		SiteForm form = new SiteForm();
		prevPage = currPage - 1;
		nextPage = currPage + 1;
		page = currPage + 1;

		model.put("sitelist", sites);

		return SUCCESS;
	}

	public List getSites() {
		return sites;
	}

	public int getCurrPage() {
		return currPage;
	}

	public void setCurrPage(int currPage) {
		this.currPage = currPage;
	}

	public int getMaxPage() {
		return maxPage;
	}

	public void setMaxPage(int maxPage) {
		this.maxPage = maxPage;
	}

	public int getMaxRowPerPage() {
		return maxRowPerPage;
	}

	public void setMaxRowPerPage(int maxRowPerPage) {
		this.maxRowPerPage = maxRowPerPage;
	}

	public int getNextPage() {
		return nextPage;
	}

	public void setNextPage(int nextPage) {
		this.nextPage = nextPage;
	}

	public String getOrderBy() {
		return orderBy;
	}

	public void setOrderBy(String orderBy) {
		this.orderBy = orderBy;
	}

	public int getPrevPage() {
		return prevPage;
	}

	public void setPrevPage(int prevPage) {
		this.prevPage = prevPage;
	}

	public int getResultRows() {
		return resultRows;
	}

	public void setResultRows(int resultRows) {
		this.resultRows = resultRows;
	}

	public void setSites(List sites) {
		this.sites = sites;
	}

	public int getPage() {
		return page;
	}

	public void setPage(int page) {
		this.page = page;
	}

}